var Ci = Components.interfaces;
var Cc = Components.classes;

var sbaspref = {
    prefs: Cc["@mozilla.org/preferences-service;1"].getService(Ci.nsIPrefService).getBranch("extensions.sbautosizer."),

    intP:  ['offsetLabel','offsetText','widthMax','widthMin','widthMin_Autocomplete_Popup'],
    boolP: ['cleanOnSubmit','revertOnSubmit','shrinkToButton','skipWizard'/*',useHelperTab' - currently no GUI! */],
//    charP: ['manualResize','tmp_WizardParams'] // set/get directly in other js code

    init: function() {
        try { if(window.arguments[0]) window.opener=window.arguments[0]; } catch(e){}
        for(p in this.intP)  document.getElementById(this.intP[p]).value    = this.prefs.getIntPref(this.intP[p]);
        for(p in this.boolP) document.getElementById(this.boolP[p]).checked = this.prefs.getBoolPref(this.boolP[p]);
//        for(p in this.charP) document.getElementById(this.charP[p]).value   = this.prefs.getCharPref(this.charP[p]);
    },

    save: function() {
        if(document.getElementById('shrinkToButton').checked)
            this.prefs.setBoolPref("addButtonToToolbar", true);

        for(p in this.intP)  this.prefs.setIntPref(this.intP[p],   document.getElementById(this.intP[p]).value);
        for(p in this.boolP) this.prefs.setBoolPref(this.boolP[p], document.getElementById(this.boolP[p]).checked);
//        for(p in this.charP) this.prefs.setCharPref(this.charP[p], document.getElementById(this.charP[p]).value);
    },

    makeOnTop: function(what) {
        if(Cc["@mozilla.org/xre/app-info;1"].getService(Ci.nsIXULRuntime).OS.toLowerCase()=='darwin') return;
        try { // Thanks to console2 extension :)
            var xulWin = window.QueryInterface(Ci.nsIInterfaceRequestor).getInterface(Ci.nsIWebNavigation).QueryInterface(Ci.nsIDocShellTreeItem).treeOwner.QueryInterface(Ci.nsIInterfaceRequestor).getInterface(Ci.nsIXULWindow);
            xulWin.zLevel = (what) ? xulWin.highestZ : xulWin.normalZ;
        } catch(e) {}
    },

}
